/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"

#ifdef CODE_SEGMENT
#pragma segment UPDATE_C
#endif

void calc_ready(struct small_creature *c) /* skills and combat stats */
    {
    long i, j;
    struct ilist *current_item;
    struct master_item *this_item;
    struct small_item *weapon;
    if (c != NULL && c->extended_creature != NULL)
        {
        c->extended_creature->sharp = c->extended_creature->blunt = c->extended_creature->penalty = 0;
        c->extended_creature->att = c->extended_creature->dmg = c->extended_creature->def = -100;
        if (flag_check(c->flags, HUMAN))
            {
            c->extended_creature->wa = -10;
            flag_set(&c->flags, C_BLUNT_DAMAGE);
            c->extended_creature->attack_time = SECOND;
            flag_reset(&c->flags, MISSLE_ATTACK);
            }
        c->extended_creature->curr_weight=(c->extended_creature->au+c->extended_creature->el+c->extended_creature->
          si+c->extended_creature->cu)/4;
        if (c->extended_creature->wear_wield)
            for(current_item=c->extended_creature->wear_wield;(!(current_item==NULL));
              current_item=current_item->next)
                if (!(flag_check(current_item->current->flags, I_VEHICLE)))
                    {
                    c->extended_creature->curr_weight+=current_item->current->weight +
                      current_item->current->weight_contained;
                    if (flag_check(current_item->current->flags, POOR_QUALITY))
                        c->extended_creature->penalty += master_items[current_item->
                          current->identity][MATRIX_POOR]->penalty;
                    else if (flag_check(current_item->current->flags,
                      FINE_QUALITY))
                        c->extended_creature->penalty += master_items[current_item->
                          current->identity][MATRIX_FINE]->penalty;
                    else
                        c->extended_creature->penalty += master_items[current_item->
                          current->identity][MATRIX_NORMAL]->penalty;
                    /* sprintf(message, "%ld %ld %ld %ld %ld",
                      master_items[current_item->
                      current->identity][MATRIX_NORMAL]->flags2,
                      master_items[current_item->
                      current->identity][MATRIX_FINE]->flags2,
                      master_items[current_item->
                      current->identity][MATRIX_POOR]->flags2,
                      orig_items[current_item->
                      current->identity]->flags2,
                      current_item->current->flags2);
                    marker(message); */
                    }
        if (c->extended_creature->pack)
            for(current_item=c->extended_creature->pack;(!(current_item==NULL));
              current_item=current_item->next)
                if (current_item->current != NULL)
                    c->extended_creature->curr_weight +=
                      current_item->current->weight +
                      current_item->current->weight_contained;
        while (item_is_in_ilist(NULL, c->extended_creature->pack))
            find_and_remove_item(NULL, &c->extended_creature->pack);
        if (c->extended_creature->mount != NULL)
            c->extended_creature->penalty += attribute_adjust(0
              /(10*LB), 0 - c->extended_creature->attributes[ST]);
        else
            c->extended_creature->penalty += attribute_adjust(c->extended_creature->curr_weight
              /(10*LB), 0 - c->extended_creature->attributes[ST]);
        for(i=0;i<NUM_ATTRIBUTES;++i)
            {
            c->extended_creature->attributes[i] = c->extended_creature->perm_attributes[i];
            for (j=0;j<NUM_STATI;++j)
                c->extended_creature->attributes[i] += (status_check(c, j) *
                  adjustment_info[j].adjustments[i]);
            }
        /*
        if (flag_check(game_variables->flags, DEBUG))
            for(i = 0; i < NUM_STATI; ++i)
                if ((i == STATUS_COLD) ||
                  (i == STATUS_FATIGUED) ||
                  (i == STATUS_HUNGRY) ||
                  (i == STATUS_PASSED_OUT) ||
                  (i == STATUS_THIRSTY) ||
                  (i == STATUS_WOUNDED))
                    if (status_check(c, i) > 10)
                        {
                        sprintf(message, "i is %ld", i);
                        fs_pmsg(message);
                        sprintf(message, "value: %ld", status_check(c, i));
                        fs_pmsg(message);
                        }
        */
        c->extended_creature->penalty = max(0, c->extended_creature->penalty -
          max(0, c->extended_creature->attributes[ST]));
        c->extended_creature->attributes[AG] -= c->extended_creature->penalty;
        c->extended_creature->attributes[DE] -= c->extended_creature->penalty;
        c->extended_creature->attributes[SPEED] -= c->extended_creature->penalty;
        c->extended_creature->att=c->extended_creature->skills->av[ATTACK_UNARMED];
        for(i=0;i<NUM_SKILLS;++i)
            {
            c->extended_creature->skills->mod[i]=0;
            for(j=0;j<NUM_ATTRIBUTES;++j)
                c->extended_creature->skills->mod[i] +=
                  c->extended_creature->attributes[j]*skill_info[i].adjustments[j];
            if (!(c->extended_creature->wear_wield == NULL))
                for(current_item=c->extended_creature->wear_wield;
                  (!(current_item==NULL)); current_item=current_item->next)
                    {
                    if (flag_check(current_item->current->flags, FINE_QUALITY))
                        this_item =
                          master_items[current_item->current->identity]
                          [MATRIX_FINE];
                    else if (flag_check(current_item->current->flags,
                      POOR_QUALITY))
                        this_item =
                          master_items[current_item->current->identity]
                          [MATRIX_POOR];
                    else
                        this_item =
                          master_items[current_item->current->identity]
                            [MATRIX_NORMAL];
                    if (this_item->skill_adjust[0][0] == i)
                        c->extended_creature->skills->mod[i] +=
                          this_item->skill_adjust[0][1];
                    if (this_item->skill_adjust[1][0] == i)
                        c->extended_creature->skills->mod[i] +=
                          this_item->skill_adjust[1][1];
                    if ((flag_check(this_item->flags2, IS_WEAPON)) &&
                      (flag_check(orig_items[this_item->identity]->slots,
                      PRIMARY_HAND)))
                        {
                        if (!(flag_check(this_item->flags2, I_BLUNT_DAMAGE)))
                            flag_reset(&c->flags, C_BLUNT_DAMAGE);
                        c->extended_creature->wa = this_item->wa;
                        c->extended_creature->attack_time = this_item->time;
                        c->extended_creature->att=
                          max(c->extended_creature->skills->av[this_item->
                          skill_enable[0]], c->extended_creature->skills->av
                          [this_item->skill_enable[1]])-c->extended_creature->haste;
                        c->extended_creature->def=max(c->extended_creature->skills->av[DODGE] -
                          c->extended_creature->haste,c->extended_creature->skills->av
                          [this_item->skill_enable[1]] - c->extended_creature->haste);
                        if (flag_check(this_item->flags2, I_MISSLE_WEAPON))
                            flag_set(&c->flags, MISSLE_ATTACK);
                        }
                    /* Change this later.  */
                    c->extended_creature->sharp = (100 - (100 - c->extended_creature->sharp) *
                      (100 - this_item->sharp) / 100);
                    c->extended_creature->blunt = (100 - (100 - c->extended_creature->blunt) *
                      (100 - this_item->blunt) / 100);
                    if (flag_check(this_item->flags2, I_BLUNT_DAMAGE))
                        flag_set(&c->flags, C_BLUNT_DAMAGE);
                    }
            c->extended_creature->skills->av[i]=c->extended_creature->skills->bv[i]+
              c->extended_creature->skills->mod[i] + skill_info[i].learning_difficulty
              - c->extended_creature->haste;
            if (i == DODGE)
                c->extended_creature->def = c->extended_creature->skills->av[i];
            }
        c->extended_creature->att = max(c->extended_creature->att,
          c->extended_creature->skills->av[ATTACK_UNARMED]);
        if (flag_check(c->flags, HUMAN))
            {
            c->extended_creature->dmg=c->extended_creature->attributes[ST]+
              c->extended_creature->wa+c->extended_creature->attributes[ST]+
              c->extended_creature->skills->av[ANATOMY]/2;
            weapon = find_weapon(c);
            if (weapon != NULL)
                if (weapon->uses > 0)
                    c->extended_creature->dmg += weapon->other;
            c->extended_creature->phv=c->extended_creature->perm_attributes[ST]+c->extended_creature->
              perm_attributes[CO]+c->extended_creature->perm_attributes[ST]+c->
              extended_creature->skills->av[ANATOMY]/2;
            }
        else
            {
            c->extended_creature->dmg=c->extended_creature->attributes[ST]+c->extended_creature->wa +
              c->extended_creature->po;
            c->extended_creature->phv=c->extended_creature->perm_attributes[ST]+c->extended_creature->
              perm_attributes[CO];
            }
        if (c == player)
            max_player_phv = max(max_player_phv, c->extended_creature->phv +
              abs(c->extended_creature->stati->time[STATUS_WOUNDED]));
        c->att = c->extended_creature->att;
        c->dmg = c->extended_creature->dmg;
        c->hv = c->extended_creature->phv - c->extended_creature->stati->time[STATUS_WOUNDED];
        c->sp = c->extended_creature->attributes[SPEED] + c->extended_creature->haste;
        c->def = c->extended_creature->def;
        c->sharp = c->extended_creature->sharp;
        c->blunt = c->extended_creature->blunt;
        c->attack_time = c->extended_creature->attack_time;
        c->extended_creature->stati->time[STATUS_WOUNDED] = max(0,
          c->extended_creature->stati->time[STATUS_WOUNDED]);
        if (c->extended_creature->stati->time[STATUS_WOUNDED] > 100)
            creature_death(c);
        }
    }
