/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"
#include <math.h>

#ifdef CODE_SEGMENT
#pragma segment UTIL6_C
#endif

void dump_core(void)
    {
#ifdef MAC_68k
    exit(1);
#else
    int x;
    x = 1;
    x = 1 / (x - 1);
#endif
    }

void find_pronoun(struct small_creature *c, char *result)
    {
    if (c != NULL)
        {
        if (flag_check(c->flags, HUMAN))
            {
            if (c->extended_creature != NULL)
                switch(c->extended_creature->gender)
                    {
                    case MALE:
                        strncpy(result, "he", 255);
                    break;
                    case FEMALE:
                        strncpy(result, "she", 255);
                    break;
                    default:
                        strncpy(result, "it", 255);
                    break;
                    }
            else
                switch(trandom() % 2)
                    {
                    case 0:
                        strncpy(result, "he", 255);
                    break;
                    default:
                        strncpy(result, "she", 255);
                    break;
                    }
            }
        else
            strncpy(result, "it", 255);
        }
    else
        strncpy(result, "", 255);
    result[255] = '\0';
    }

void check_creature(struct small_creature *c)
    {
#ifdef DEBUG
    char message[256];
#endif
    c = c; /* For if compiled without DEBUG defined.  */
#ifdef DEBUG
    if ((c->identity < 0) || (c->identity >= NUM_CREATURES))
        {
#ifdef HAS_SNPRINTF
        snprintf(message, 255, "Out of range creature identity %ld!", c->identity);
#else
        sprintf(message, "Out of range creature identity %ld!", c->identity);
#endif
        message[255] = '\0';
        string_check_exit(message);
        }
    else if ((c->x < 0) || (c->x >= MAX_X) || (c->y < 0) || (c->y >= MAX_Y))
        {
#ifdef HAS_SNPRINTF
        snprintf(message, 255, "Out of range creature x or y (%ld, %ld)!", c->x,
          c->y);
#else
        sprintf(message, "Out of range creature x or y (%ld, %ld)!", c->x,
          c->y);
#endif
        message[255] = '\0';
        string_check_exit(message);
        }
#endif
    }

void string_check_exit(char *message)
    {
    window_clear();
    fs_pmsg(message);
#ifdef DEBUG
#ifdef GTK
    if (tms_confirm("Exit and dump core?"))
#else
    fs_pmsg("Exit and dump core?");
    if (confirm_silent())
#endif
        {
        fs_pmsg("Dumping core to enable analysis...");
        dump_core();
        }
#endif
    }

void check_xy(long x, long y)
    {
#ifdef DEBUG
    char message[256];
#elif __MWERKS__
#pragma unused(x, y)
#endif
#ifdef DEBUG
    if ((x < 0) || (x >= MAX_X))
        {
#ifdef HAS_SNPRINTF
        snprintf(message, 255, "Out of range x value: %ld!", x);
#else
        sprintf(message, "Out of range x value: %ld!", x);
#endif
        message[255] = '\0';
        string_check_exit(message);
        }
    if ((y < 0) || (y >= MAX_Y))
        {
#ifdef HAS_SNPRINTF
        snprintf(message, 255, "Out of range y value: %ld!", y);
#else
        sprintf(message, "Out of range y value: %ld!", y);
#endif
        message[255] = '\0';
        string_check_exit(message);
        }
#endif
    }

void check_string(char *string)
    {
    string = string;
#ifdef DEBUG
    if (strlen(string) > 254)
        {
#ifndef GTK
        printw("\nExcessive string length %ld: string:\n%s\n", strlen(string),
          string);
#endif
        window_refresh();
        }
#endif
    }

void check_pointer(struct pointer_struct *test_pointer)
    {
    if ((test_pointer != NULL) && (!(flag_check(game_variables->flags,
      DURING_INIT))))
        {
#ifdef DEBUG
        /*
        if ((abs((int) test_pointer) < 0xffff) || (abs(((int) test_pointer) -
          0xffffff) < 0xff))
            {
            pmsg("Error! Invalid pointer.  Dump core?");
            if (confirm_silent())
                dump_core();
            }
        else */ if (test_pointer != test_pointer->me)
            {
#ifdef GTK
            if (tms_confirm("Error! Invalid pointer. Dump core?"))
#else
            pmsg("Error! Invalid pointer. Dump core?");
            if (confirm_silent())
#endif
                dump_core();
            }
#endif
        }
    }

void check_level_pointers(struct level *l)
    {
    long i, j;
    struct clist *cl;
    struct ilist *il;
    for(i = 0; i < MAX_X; ++i)
        for(j = 0; j < MAX_Y; ++j)
            {
            if (l->space[i][j].creatures != NULL)
                for(cl = l->space[i][j].creatures; cl != NULL; cl = cl->next)
                    {
                    check_pointer((struct pointer_struct *) cl);
                    check_pointer((struct pointer_struct *) cl->current);
                    check_creature(cl->current);
                    }
            if (l->space[i][j].items != NULL)
                for(il = l->space[i][j].items; il != NULL; il = il->next)
                    {
                    check_pointer((struct pointer_struct *) il);
                    check_pointer((struct pointer_struct *) il->current);
                    check_pointer((struct pointer_struct *)
                      il->current->writing);
                    check_pointer((struct pointer_struct *) il->current->tname);
                    }
            if (l->space[i][j].special != NULL)
                if (l->space[i][j].special->shop != NULL)
                    {
                    if (l->space[i][j].special->shop->creatures != NULL)
                        for(cl = l->space[i][j].special->shop->creatures; cl
                          != NULL; cl = cl->next)
                            {
                            check_pointer((struct pointer_struct *) cl);
                            check_pointer((struct pointer_struct *)
                              cl->current);
                            check_creature(cl->current);
                            }
                    if (l->space[i][j].special->shop->items != NULL)
                        for(il = l->space[i][j].special->shop->items; il !=
                          NULL; il = il->next)
                            {
                            check_pointer((struct pointer_struct *) il);
                            check_pointer((struct pointer_struct *)
                              il->current);
                            check_pointer((struct pointer_struct *)
                              il->current->writing);
                            check_pointer((struct pointer_struct *)
                              il->current->tname);
                            }
                    }
            }
    }

void end_game(void)
    {
    flag_set(&game_variables->flags, DURING_INIT);
    if (master_llist != NULL)
	{
	free_levels(master_llist);
	master_llist = NULL;
	}
    if (master_clist != NULL)
	{
	free_creatures(master_clist);
	master_clist = NULL;
	}
    if (master_ilist != NULL)
	{
	free_items(master_ilist);
	master_ilist = NULL;
	}
    flag_set(&game_variables->flags, IN_BETWEEN_GAMES);
    /*
    remove_main_window_contents();
    clear_pmsg();
    */
    /* Wait until something happens.  */
    }

void my_finish(long status)
    {
#ifndef MAC_68k
    if (status == 0)
        {
        window_clear();
        pmsg("Bye!");
        fs_morewait();
        }
    /*
    nocbreak();
    echo();
    window_refresh();
    endwin();
    exit(status);
    */
#else
    long dummy;
    dummy = status;
    exit(0);
#endif
    }

void my_ltostr(char* target, long number)
    {
    long digit, index, sign, workbench;
    if (number == 0L)
        {
        strcpy(target, "0");
        return;
        }
    if (number > 0)
        {
        sign = 1;
        }
    else
        {
        sign = -1;
        }
    workbench = abs(number);
    while (workbench > 0)
        {
        digit = workbench % 10;
        workbench = workbench / 10;
        for(index = strlen(target); index >= 0; --index)
            if (index > 0)
                target[index] = target[index - 1];
            else
                target[index] = '0' + digit;
        }
    if (sign == -1)
        for(index = strlen(target); index >= 0; --index)
            if (index > 0)
                target[index] = target[index - 1];
            else
                target[index] = '-';
    }

void my_noop(void)
    {
    ;
    }

long dequeue_request(void)
    {
    struct request_queue_struct *new_beginning;
    long result;
    if (user_requests == NULL)
        {
        return MENU_QUEUE_EMPTY;
        }
    else
        {
        result = user_requests->current;
        new_beginning = user_requests->next;
        free(user_requests);
        user_requests = new_beginning;
        return result;
        }
    }

void enqueue_request(long request_identifier)
    {
    struct request_queue_struct *new_queue_segment, *traverse;
    new_queue_segment = (struct request_queue_struct *) calloc(1, sizeof(struct
      request_queue_struct));
    new_queue_segment->me = new_queue_segment;
    new_queue_segment->current = request_identifier;
    new_queue_segment->next = NULL;
    if (user_requests == NULL)
        {
        user_requests = new_queue_segment;
        }
    else
        {
        for (traverse = user_requests; traverse->next != NULL; traverse =
          traverse->next)
            my_noop();
        traverse->next = new_queue_segment;
        }
    }

long keystroke_to_command(char keystroke)
    {
    switch(keystroke)
        {
        case 0:
            return MENU_QUEUE_EMPTY;
        break;
        case LEFT: case SECOND_LEFT:
            return MENU_MOVEMENT_LEFT;
        break;
        case DOWN: case SECOND_DOWN:
            return MENU_MOVEMENT_DOWN;
        break;
        case UP: case SECOND_UP:
            return MENU_MOVEMENT_UP;
        break;
        case RIGHT: case SECOND_RIGHT:
            return MENU_MOVEMENT_RIGHT;
        break;
        case UP_LEFT: case SECOND_UP_LEFT:
            return MENU_MOVEMENT_UP_AND_LEFT;
        break;
        case UP_RIGHT: case SECOND_UP_RIGHT:
            return MENU_MOVEMENT_UP_AND_RIGHT;
        break;
        case DOWN_LEFT: case SECOND_DOWN_LEFT:
            return MENU_MOVEMENT_DOWN_AND_LEFT;
        break;
        case DOWN_RIGHT: case SECOND_DOWN_RIGHT:
            return MENU_MOVEMENT_DOWN_AND_RIGHT;
        break;
        case JOG_LEFT:
            return MENU_MOVEMENT_DOWN_AND_LEFT;
        break;
        case JOG_DOWN:
            return MENU_MOVEMENT_JOG_DOWN;
        break;
        case JOG_RIGHT:
            return MENU_MOVEMENT_JOG_RIGHT;
        break;
        case JOG_UP_LEFT:
            return MENU_MOVEMENT_JOG_UP_AND_LEFT;
        break;
        case JOG_UP_RIGHT:
            return MENU_MOVEMENT_JOG_UP_AND_RIGHT;
        break;
        case JOG_DOWN_LEFT:
            return MENU_MOVEMENT_JOG_DOWN_AND_LEFT;
        break;
        case JOG_DOWN_RIGHT:
            return MENU_MOVEMENT_JOG_DOWN_AND_RIGHT;
        break;
        case RUN_LEFT:
            return MENU_MOVEMENT_RUN_LEFT;
        break;
        case RUN_DOWN:
            return MENU_MOVEMENT_RUN_DOWN;
        break;
        case RUN_UP:
            return MENU_MOVEMENT_RUN_UP;
        break;
        case RUN_RIGHT:
            return MENU_MOVEMENT_RUN_RIGHT;
        break;
        case RUN_UP_LEFT:
            return MENU_MOVEMENT_RUN_UP_AND_LEFT;
        break;
        case RUN_UP_RIGHT:
            return MENU_MOVEMENT_RUN_UP_AND_RIGHT;
        break;
        case RUN_DOWN_LEFT:
            return MENU_MOVEMENT_RUN_DOWN_AND_LEFT;
        break;
        case RUN_DOWN_RIGHT:
            return MENU_MOVEMENT_RUN_DOWN_AND_RIGHT;
        break;
        case REFRESH:
            return MENU_UNUSED;
        break;
        case ACTIVATE:
            return MENU_ACTIONS_ACTIVATE_AN_ITEM;
        break;
        case CLOSE_ITEM:
            return MENU_ACTIONS_CLOSE_AN_ITEM;
        break;
        case DROP:
            return MENU_ACTIONS_DROP_AN_ITEM;
        break;
        case EQUIP:
            return MENU_ACTIONS_EQUIP_IE_START_USING_AN_ITEM;
        break;
        case FIRE_THROW:
            return MENU_ACTIONS_FIRE_OR_THROW_A_MISSLE_WEAPON;
        break;
        case GIVE:
            return MENU_ACTIONS_GIVE_AN_ITEM_TO_ANOTHER_CREATURE;
        break;
        case INVENTORY:
            return MENU_OTHER_DISPLAY_AN_INVENTORY_OF_ITEMS_IN_YOUR_POSSESSION;
        break;
        case MUNCH:
            return MENU_ACTIONS_EAT_MUNCH_FOOD;
        break;
        case OPEN_ITEM:
            return MENU_ACTIONS_OPEN_AN_ITEM;
        break;
        case PRAY:
            return MENU_UNUSED;
        break;
        case QUAFF:
            return MENU_ACTIONS_DRINK_QUAFF_A_LIQUID;
        break;
        case READ_ITEM:
            return MENU_ACTIONS_READ_AN_ITEM;
        break;
        case USE_SKILL:
            return MENU_UNUSED;
        break;
        case TALK:
            return MENU_ACTIONS_TALK_TO_ANOTHER_PERSON;
        break;
        case VAULT:
            return MENU_ACTIONS_JUMP_VAULT_FROM_ONE_LOCATION_TO_ANOTHER;
        break;
        case WALK:
            return MENU_ACTIONS_START_WALKING;
        break;
        case EXAMINE_ITEM:
            return
              MENU_ACTIONS_EXAMINE_AN_ITEM_IN_YOUR_POSSESSION_MORE_CLOSELY;
        break;
        case ALLOCATE_EXPERIENCE:
            return MENU_OTHER_ALLOCATE_EXPERIENCE;
        break;
        case CLOSE_DOOR:
            return MENU_ACTIONS_CLOSE_A_DOOR;
        break;
        case DO_ACTION:
            return MENU_UNUSED;
        break;
        case UNEQUIP:
            return MENU_ACTIONS_UNEQUIP_IE_REMOVE_AN_ITEM_IN_USE;
        break;
        case FLY:
            return MENU_ACTIONS_FLY_OR_LAND;
        break;
        case GO_TO_SLEEP:
            return MENU_ACTIONS_GO_TO_SLEEP;
        break;
        case INSPECT_SEARCH:
            return MENU_ACTIONS_SEARCH_INSPECT_THE_SURROUNDING_AREA;
        break;
        case CITY_MOVE:
            return MENU_ACTIONS_MOVE_TO_A_CITY_LOCATION;
        break;
        case OPEN_DOOR:
            return MENU_ACTIONS_OPEN_A_DOOR;
        break;
        case PRINT_COPYRIGHT:
            return MENU_OTHER_DISPLAY_LICENSE_STATEMENT;
        break;
        case QUIT:
            return MENU_FILE_QUIT_THE_MINSTRELS_SONG;
        break;
        case ROLE_PLAY_INFO:
            return MENU_UNUSED;
        break;
        case SAVE:
            return MENU_FILE_SAVE_GAME;
        break;
        case THANKS:
            return MENU_UNUSED;
        break;
        case WRITE_ON_ITEM:
            return MENU_UNUSED;
        break;
        case EXAMINE_SPACE:
            return MENU_ACTIONS_EXAMINE_YOUR_SURROUNDINGS_MORE_CLOSELY;
        break;
        case ACTIVATE_SPACE:
            return MENU_ACTIONS_ACTIVATE_YOUR_LOCATION;
        break;
        case REST_ONCE:
            return MENU_ACTIONS_REST_A_MOMENT;
        break;
        case REST_AWHILE:
            return MENU_ACTIONS_REST_OR_WAIT_FOR_A_WHILE;
        break;
        case ENTER_OR_EXIT:
            return MENU_ACTIONS_ENTER_OR_EXIT_A_LEVEL;
        break;
        case ABRIDGED_HELP:
            return MENU_UNUSED;
        break;
        case HELP:
            return MENU_UNUSED;
        break;
        default:
            return MENU_UNUSED;
        break;
        case MAKE_THE_DISPLAY_TALLER:
            return MENU_OTHER_MAKE_THE_DISPLAY_TALLER;
        break;
        case MAKE_THE_DISPLAY_SHORTER:
            return MENU_OTHER_MAKE_THE_DISPLAY_SHORTER;
        break;
        case MAKE_THE_DISPLAY_WIDER:
            return MENU_OTHER_MAKE_THE_DISPLAY_WIDER;
        break;
        case MAKE_THE_DISPLAY_NARROWER:
            return MENU_OTHER_MAKE_THE_DISPLAY_NARROWER;
        break;
        }
    }

void convert_text_struct_to_string_array(struct text_struct *text, char
  ***string_array, long *number_of_items)
    {
    struct text_struct *traverse;
    long i, string_length;
    char **new_array;
    *number_of_items = 0;
    for(traverse = text; traverse != NULL; traverse = traverse->next)
        ++*number_of_items;
    /*
    *string_array = calloc(*number_of_items, sizeof(char *));
    */
    new_array = calloc(*number_of_items, sizeof(char *));
    traverse = text;
    for(i = 0; i < *number_of_items; ++i)
        {
        string_length = strlen(traverse->text) + 1;
        /*
        *string_array[i] = NULL;
        *string_array[i] = calloc(string_length, sizeof(char));
        *string_array[i] = calloc(strlen(traverse->text) + 1, sizeof(char));
        strncpy(*string_array[i], traverse->text, strlen(traverse->text));
        */
        new_array[i] = calloc(string_length, sizeof(char));
        strncpy(new_array[i], traverse->text, strlen(traverse->text));
        traverse = traverse->next;
        }
    *string_array = new_array;
    }

struct small_creature *select_creature(struct clist *creatures, long flags)
    {
    struct small_creature *result;
    struct text_struct *text;
    char **strings;
    long number_of_creatures, current_slot, choice;
    number_of_creatures = current_slot = 0;
    strings = NULL;
    text = NULL;
    compile_text_from_clist(&text, creatures, flags);
    append_text_to_text_struct(&text, "Never mind.");
    convert_text_struct_to_string_array(text, &strings, &number_of_creatures);
    choice = menu_choice("Which item do you want?", strings,
      number_of_creatures);
    if (choice < number_of_creatures - 1)
        result = extract_creature(&creatures, flags);
    else
        result = NULL;
    free_text_struct(text);
    free_string_array(strings, number_of_creatures);
    return result;
    }

struct small_item *select_item(struct ilist **items, long flags)
    {
    struct small_item *result;
    struct text_struct *text;
    char **strings;
    long number_of_items, current_slot, choice;
    number_of_items = current_slot = 0;
    strings = NULL;
    text = NULL;
    compile_text_from_ilist(&text, *items, flags);
    append_text_to_text_struct(&text, "Never mind.");
    convert_text_struct_to_string_array(text, &strings, &number_of_items);
    choice = menu_choice("Which item do you want?", strings, number_of_items);
    if (choice < number_of_items - 1)
        result = extract_item(items, 0, &current_slot, choice, flags);
    else
        result = NULL;
    free_text_struct(text);
    free_string_array(strings, number_of_items);
    return result;
    }

long item_is_in_ilist(struct small_item *item, struct ilist *list)
    {
    struct ilist *traverse;
    for(traverse = list; traverse != NULL; traverse = traverse->next)
        if (traverse->current == NULL)
            return 1;
    return 0;
    }

void capitalize_text_in_text_struct(struct text_struct *text)
    {
    struct text_struct *traverse;
    for(traverse = text; traverse != NULL; traverse = traverse->next)
        if (traverse->text[0] >= 'a' && traverse->text[0] <= 'z')
            traverse->text[0] += 'A' - 'a';
    }
